<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.server.ScreenDefinitionEx" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
try {    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final String exportUrl = request.getContextPath() + "/ScreenDef.do?method=view";
	//final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	//final User currentUser = SecurityUtils.getUser(psession);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function popupCloser_refresh() {
         document.getElementById('queryForm').submit();
      }
      
      function performDelete(handle, title) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "cpb.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(title));
         if (confirm(msg)) {
            performAction("delete", handle, true);
         }
      }
      
      function performDeactivate(handle, title, type) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
          "cpb.deactivate.confirm.message.fmt")) %>");
         msg = formatMessage(msg, unescape(title), type);
         
         if (confirm(msg)) {
            performAction("deactivate", handle, true);
         }
      }
      
      function performAction(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/ScreenDef.do"
               + "?method=" + method;
         if (handle) {
            document.forms.queryForm.action += "&handle=" + encodeURI(handle);
         }
         document.forms.queryForm.submit();
      }
      
      function performDownload(handle) {
         performAction("download", handle);
         
         // put action back the way it was
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/ScreenDefQuery.do";
      }
      
      function showContextMenu(handle, active, title, type) {
         enabled = true;
         deleteEnabled=true;
         var menu = new TableMenu();
         <c:if test="${canUpload}">
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
                     "<%= request.getContextPath() %>/" + "<fmt:message key='application.previewresults.image'/>" , 
                     "<fmt:message key='application.preview.txt'/>", "javascript:performAction('preview', '" + handle + "')", 
                     enabled));     
            
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
                     "<%= request.getContextPath() %>/" + (active=='true' ? "<fmt:message key='application.deactivate.image'/>" : "<fmt:message key='application.activate.image'/>"), 
                     active=='true'? "<fmt:message key='application.deactivate.txt'/>" : "<fmt:message key='application.activate.txt'/>", 
                     active=='true'? "javascript:performDeactivate('" + handle + "', '" + title + "', '" + type + "')" 
                                   : "javascript:performAction('activate', '" + handle + "')", 
                     enabled));
         </c:if>
         
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
                  "<%= request.getContextPath() %>/" + "<fmt:message key='application.download.image'/>" , 
                  "<fmt:message key='application.download.txt'/>", "javascript:performDownload('" + handle + "')", 
                  enabled));        
         
         <c:if test="${canUpload}">
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
                  "<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>", 
                  "<fmt:message key='application.button.delete.txt'/>", 
                  "javascript:performDelete('" + handle + "','" + title+ "')",deleteEnabled));
                  
         </c:if>
         menu.render();
            return false;
      }
      
      function newUpload() {
         openModal(
            "<%= request.getContextPath() %>" 
            + "/ScreenDef.do?method=newUpload",
            "newUploadPopup");
      }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScreenDefQuery">     
         
         <mon:Content>
            
            <mon:tableComponent id="screenDefs" exportXlsUrl="<%= exportUrl %>" >
               <c:if test="${canUpload}">
                  <mon:action href="javascript:newUpload();">
                     <fmt:message key='cpb.uploadDefinition.txt'/>
                  </mon:action>
               </c:if>
               <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
               
            <% 
                     final ScreenDefinitionEx screenDefs = (ScreenDefinitionEx)pageContext.findAttribute("screenDefs");
                     final String active = screenDefs.getActiveFlg().toString(); 
                     final String title = ParsingUtils.escape(screenDefs.getScreenDefinitionTitle());
                     final String type = screenDefs.getScreenDefinitionTypeCd().getValue();
            %>
                  &nbsp;<a href="#" onclick="return showContextMenu('<c:out value='${screenDefs.handleString}'/>','<%= active %>', '<%= title %>', '<%= type %>')"
                  ><img border="0"  src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>"
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  /></a>&nbsp;
                  </mon:fixedColumn>
               
            </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
<%
} catch (Exception e) {
	e.printStackTrace();
}
%>
