<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.Issue" %>
<%@ page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.issues.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.fsd.shared.json.JSONEncoder"%><%
   ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());

   IssuesTableTag.IssueTableModel model = 
      (IssuesTableTag.IssueTableModel)request.getAttribute("issueTableModel"); 
%>

<mon:include js="/script/checkboxRadioUtil.js" />
<mon:include js="/dwr/engine.js" />
<mon:include js="/dwr/util.js" />
<mon:include js="/dwr/interface/IAPService.js" />

<script type="text/javascript">

var issuesTableModel = <%= JSONEncoder.toJSONString(model) %>; 

<%-- Create a new Issue --%>
function createIssue() {
   var url = "/LinkToIssue.do?method=create"
		+ "&tpHandle=<%= model.getPboHandle() %>";
	doIssue(url,true);
}

<%-- Choose Issue to link--%>
function chooseIssue() {
	openModal("<%= request.getContextPath() %>/LinkToIssueQuery.do"
			+ "?tpHandle=" + encodeURI("<%= model.getPboHandle() %>")
			+ "&immediateSave=<c:out value="${issueTableModel.immediateSave}" />",
		"issues_popup");
}

<%-- Link Issue --%>
function linkIssue(issueHandle) {
   var params = issuesTableModel.minimal ? {} 
     : getParamsForTable(document.forms[0], "linkedIssues");

   IAPService.addLinkedIssue(
      issueHandle, issuesTableModel, params, 
      function(pageMod) {
         closeModal("issues_popup");
         PageModification.handle("linkedIssuesDiv", pageMod);
      }
   );
}

function unlinkIssue(issueHandle, name) {
   var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
      "iap.okToUnlinkIssue.fmt.txt")) %>");
   msg = formatMessage(msg, unescape(name));
   
   if (confirm(msg)) {
      var params = issuesTableModel.minimal ? {} 
         : getParamsForTable(document.forms[0], "linkedIssues");
	      
      IAPService.removeLinkedIssue(
    		issueHandle, issuesTableModel, params, 
         function(pageMod) {
            PageModification.handle("linkedIssuesDiv", pageMod);
         }
      );
   }
}

<%-- View Issue --%>
function viewRelatedIssue(issueHandle) {
	doIssue("/Issue.do?method=select&handle=" + issueHandle);
}

<%-- perform some issue action --%>
function doIssue(path, anchor) {
   path += "&immediateSave=<c:out value="${issueTableModel.immediateSave}" />";
<%
	String jsMethod = model.getForwardMethod();
	if (jsMethod != null) {
%>
   if (typeof(<%= jsMethod %>) == 'undefined') {
      alert("No '<%= jsMethod %>' JS method defined!");
   }
	<%= jsMethod %>(path, anchor ? "linkedIssues" : "");
<%	} else { %>
	var url = "<%= request.getContextPath() %>" + path;
	if (anchor) {
		url += "#linkedIssues";
	}
	window.location = url;
<%	} %>
}

// refresh linked issues table
function refreshLinkedIssues() {
   var params = getParamsForTable(document.forms[0], "linkedIssues");

   IAPService.refreshLinkedIssues(
      issuesTableModel, params, 
      function(pageMod) {
         PageModification.handle("linkedIssuesDiv", pageMod);
      }
   );
}

</script>

<c:if test="${issueTableModel.outputForm}">
<form name="<c:out value="${issueTableModel.formName}" />">
</c:if>

<a name="linkedIssues" ></a>

<div id="linkedIssuesDiv">
<jsp:include page = "IssuesContent.jsp" />
</div>

<c:if test="${not issueTableModel.minimal}">
<script type="text/javascript">
   // override the submit function to use ajax
   getTableComponent("linkedIssues_").submit = refreshLinkedIssues;
</script>
</c:if>
<c:if test="${issueTableModel.outputForm}">
</form>
</c:if>