<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final DimensionalAreaHandle topAreaHandle = DimensionalArea.object.getTop(psession).getHandle();	
	final DimensionalPointHandle topPointHandle = DimensionalPoint.object.getTop(psession).getHandle();
%>		

/**
 * OraChooser class
 */
function OraChooser(
	id, 
	handle, 
	feature, 
	property, 
	formName, 
	selectMethod, 
	excludedDims, 
	isReadOnly, 
	isRequired, 
	isEmpty, 
	isDimPoint, 
	isCollapsible, 
	isRootVisible, 
	isEverywhereAllowed, 
	isForFiltering, 
	isAdvanced, 
	isModeSelectable, 
	isFavorite, 
	isShowMappedStandardRiskType,
	isShowMappedStandardBusinessLine,
	secureObjectClass,
	secureAction,
	parentArea,
	favorites,
	preference) 
{
	// constants
	this.WINDOW_NAME = 'oraPopup';
	this.WINDOW_FEATURES = 'width=900,height=500,scrollbars,resizable';

	// instance vars
	this.id = id;
	this.handle = handle;
	this.feature = feature;
	this.preference = preference || "";
	this.property = property;
	this.formName = formName;
	this.selectMethod = selectMethod;
	this.excludedDims = excludedDims;
	this.isReadOnly = isReadOnly;
	this.isRequired = isRequired;
	this.isEmpty = isEmpty;
	this.isDimPoint = isDimPoint;
	this.isCollapsible = isCollapsible;
	this.isRootVisible = isRootVisible;
	this.isEverywhereAllowed = isEverywhereAllowed;
	this.isForFiltering = isForFiltering;
	this.isAdvanced = isAdvanced;
	this.isModeSelectable = isModeSelectable;
	this.isFavorite = isFavorite;
	this.smsrt = isShowMappedStandardRiskType;
	this.smsbl = isShowMappedStandardBusinessLine;
	this.secureObjectClass = secureObjectClass;
	this.secureAction = secureAction;
	this.parentArea = parentArea;
	this.favorites = favorites;
	
	this.handleKey = isDimPoint ? "dpHandle" : "daHandle";
}

// define the methods of the OraChooser class
OraChooser.prototype = new Object();

/* Hook for attaching listeners that handle page changes after refreshing */
OraChooser.prototype.onRefresh = function() { }

/* Calls the select method */
OraChooser.prototype.callSelectMethod = function(handle) {
	if (typeof(handle) == "undefined") handle = this.handle;
	if (isEmpty(this.selectMethod)) {
		return true;
	}
	return window[this.selectMethod](handle);
}

/* Returns the ora action url */
OraChooser.prototype.getActionURL = function(method, handle, advanced) {
	return this.addParameters("<%= request.getContextPath() %>" 
      + "/Ora.do?method=" + method, handle, advanced);
}

/* Adds ora parameters to specified url */
OraChooser.prototype.addParameters = function(url, handle, advanced) {
	if (typeof(handle) == "undefined") handle = this.handle;
	if (typeof(advanced) == "undefined") advanced = this.isAdvanced;

	return url += 
        "&" + this.handleKey + "=" + encodeURI(handle)
      + "&dimPoint=" + this.isDimPoint
      + "&feature=" + this.feature
      + "&preference=" + this.preference
      + "&id=" + this.id
//		+ "&title=" + this.title
      + "&collapsible=" + this.isCollapsible
      + "&readOnly=" + this.isReadOnly
      + "&required=" + this.isRequired
      + "&rootVisible=" + this.isRootVisible
      + "&everywhereAllowed=" + this.isEverywhereAllowed
      + "&forFiltering=" + this.isForFiltering
      + "&advanced=" + advanced
      + "&modeSelectable=" + this.isModeSelectable
      + "&secureObjectClass=" + this.secureObjectClass
      + "&secureAction=" + this.secureAction
      + "&parentArea=" + this.parentArea
      + "&excludedDimensions=" + this.excludedDims
      + "&smsrt=" + this.smsrt
      + "&smsbl=" + this.smsbl;
}

/* Create/Modify a DimensionalPoint/Area */
OraChooser.prototype.editOra = function() {
   popupAnchor = "#ora_" + this.id;
   openModal(this.getActionURL("edit"), 
      this.WINDOW_NAME, this.WINDOW_FEATURES);
}

/* Modify a particular node in a DimensionalPoint/Area */
OraChooser.prototype.editNode = function(nodeHandle, dimValue) {
   popupAnchor = "#ora_" + this.id;
   openModal(this.getActionURL("edit") + "&node=" + nodeHandle + "&dim=" + dimValue, 
      this.WINDOW_NAME, this.WINDOW_FEATURES);
}

/* Add a new Point to an Area */
OraChooser.prototype.newPoint = function() {
   popupAnchor = "#ora_" + this.id;
   openModal(this.getActionURL("newPoint"), 
      this.WINDOW_NAME, this.WINDOW_FEATURES);
}

/* Adds the currently selected ORA as a favorite */
OraChooser.prototype.addToFavorites = function() {
   popupAnchor = "#ora_" + this.id;
   var action = this.isDimPoint ? "Favorite" : "FavoriteArea";   

   openModal(this.addParameters("<%= request.getContextPath() %>" 
	      + "/" + action + ".do?method=create"),
      this.WINDOW_NAME, "width=600,height=500,scrollbars,resizable");
}

/* Opens a window to manage favorites */
OraChooser.prototype.manageFavorites = function() {
   popupAnchor = "#ora_" + this.id;
   openModal(this.getActionURL("manageFavorites"), 
      "oraPopup2", this.WINDOW_FEATURES);
}

/* Selects the specified favorite ora */
OraChooser.prototype.selectFavorite = function(oraHandle) {
	this.oraSelected(oraHandle);
}

/* Shows a list of favorite oras */
OraChooser.prototype.showFavorites = function() {
	var menu = new TableMenu();
	menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='application.addrow.image'/>", "<fmt:message key='favorites.addToFavorites.button.txt'/>", "javascript:" + this.id + "Chooser.addToFavorites()", (!this.isEmpty && !this.isFavorite)));
	menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='application.edit.image'/>", "<fmt:message key='favorites.manageFavorites.button.txt'/>", "javascript:" + this.id + "Chooser.manageFavorites()"));
	menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
	if (this.isEverywhereAllowed) {
	   var topHandle = this.isDimPoint ? '<%= topPointHandle %>' : '<%= topAreaHandle %>';
	   menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='application.favorite.image'/>", 
	   	"<fmt:message key='ora.everywhere.button.txt' />", "javascript:" + this.id + "Chooser.selectFavorite('" + topHandle + "')"));
		menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
	}
	for (var i = 0; i < this.favorites.length; i++) {
		var fav = this.favorites[i];
	   menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='application.favorite.image'/>", fav.name, "javascript:" + this.id + "Chooser.selectFavorite('" + fav.handle + "')", fav.enabled));
	}
	menu.render();
	return false;
}

/* Refreshes the chooser with the specified ora */
OraChooser.prototype.refreshChooser = function(handle, advanced) {
	var oraFrame = window.frames[this.id + 'Frame'];
	viewUrl(this.getActionURL("refreshChooser", handle, advanced), oraFrame);
}

/* Popup editor has closed with an ora selected */
OraChooser.prototype.oraSelected = function(handle) {
	if (typeof(handle) == "undefined") handle = this.handle;
	this.updatePropertyValue(handle);
   
   var currentView = document.getElementById('TCCurrentView');
   if (currentView){
      currentView.value = "";
   }
   
   var loadDefaultView = document.getElementById('TCLoadDefaultView');
   if (loadDefaultView){
      loadDefaultView.value = "0";
   }

	// call the selectMethod	
	if (this.callSelectMethod(handle)) {
		// if the selectMethod returns true, continue with the auto-refresh
		this.refreshChooser(handle);
	}
}

/* Updates the form property, if it can. */
OraChooser.prototype.updatePropertyValue = function(handle) {
	if (typeof(handle) == "undefined") handle = this.handle;
	
	// if we can, set the property with the new value
	if (!isEmpty(this.property) && !isEmpty(this.formName)) {
		document.forms[this.formName][this.property].value = handle;
	}
}

OraChooser.prototype.sloshFrom = function(otherChooser) {
	this.handle = otherChooser.handle;
	this.isEmpty = otherChooser.isEmpty;
	this.favorites = otherChooser.favorites;
	this.isFavorite = otherChooser.isFavorite;
	this.isAdvanced = otherChooser.isAdvanced;
	this.updatePropertyValue(this.handle);
}

/* Clears selected location */
OraChooser.prototype.clear = function() {
	var msg = this.isDimPoint ? "<fmt:message key='ora.confirmClearPoint.txt'/>"
		: "<fmt:message key='ora.confirmClearArea.txt'/>";
	if (confirm(msg)) {
		this.oraSelected('');
	}
}

/* Sets the mode of the chooser (basic or advanced) */
OraChooser.prototype.setAdvanced = function(advanced) {
	this.refreshChooser(this.handle, advanced);
}

/* Saves the expanded/collapsed state of the chooser */
OraChooser.prototype.saveExpandedState = function(expanded) {
	var oraFrame = window.frames[this.id + 'Frame'];
   viewUrl(this.getActionURL("saveExpandedState")
      + "&expanded=" + expanded, oraFrame);
}

/* Creates a new point to be added to the current area */
OraChooser.prototype.newPoint = function(dimValue) {
	popupAnchor = "#ora_" + this.id;
	openModal(this.getActionURL("newPoint") 
		+ (dimValue ? "&dim=" + dimValue : ""), 
		this.WINDOW_NAME, this.WINDOW_FEATURES);
}

/* Edits a point in the current area */
OraChooser.prototype.editPoint = function(dpHandle, nodeHandle, dimValue) {
	popupAnchor = "#ora_" + this.id;
	openModal(this.getActionURL("editPoint") + "&dpHandle=" + encodeURI(dpHandle)
		+ (nodeHandle ? "&node=" + encodeURI(nodeHandle) : "")
		+ (dimValue ? "&dim=" + encodeURI(dimValue) : ""), 
		this.WINDOW_NAME, this.WINDOW_FEATURES);
}

/* Removes a point in the current area */
OraChooser.prototype.removePoint = function(dpHandle) {
	var oraFrame = window.frames[this.id + 'Frame'];
   viewUrl(this.getActionURL("removePoint") + "&dpHandle=" + encodeURI(dpHandle), oraFrame);
}

/**
 * Favorite class
 */
function Favorite(name, handle, enabled, tip) {
	this.name = name;
	this.handle = handle;
	this.enabled = enabled;
	this.tip = tip;
}

function isEmpty(value) {
	return (typeof(value) == "undefined") || (value == null) || ("" == value);
}
