<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ScenarioWizardForm" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>

<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   
   final String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
%>

<mon:Page template="details">
   <mon:Head>      
      <mon:include js="/script/checkboxRadioUtil.js" />
      
      <script type="text/javascript">    
      
      function viewAssessors(roleHandle, areaHandle) {
         var form = document.forms.assessmentsForm;
         
         form.action = "<%= request.getContextPath() %>/Scenarios.do"
            + "?method=viewAssessors"
            + "&roleHandle=" + encodeURI(roleHandle)
            + "&areaHandle=" + encodeURI(areaHandle);
         form.submit();
      }
      
      function preview(answerSheetHandle) {
         var form = document.forms.assessmentsForm;
         
         form.action = "<%= request.getContextPath() %>/Scenarios.do"
            + "?method=previewAnswerSheet"
            + "&answerSheetHandle=" + encodeURI(answerSheetHandle);
         form.submit();
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/Scenarios?method=open">      
         <mon:ToolBar>
            <mon:Button name="openButton" onclick="submit();">
               <fmt:message key='Scenarios.button.openScenario.txt' />
            </mon:Button>
            <mon:Button name="cancelButton" onclick="breadcrumb()">
               <fmt:message key='application.cancel.txt' />
            </mon:Button>
         </mon:ToolBar>
         
         <mon:Content>
            <html:hidden property="handle" />
            
            <p class="instructions"><fmt:message key="Scenarios.openScenario.instructions.txt" /></p>            
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="answerSheets" id="entry">
            <%
               AssessmentAnswerSheet answerSheet = (AssessmentAnswerSheet)
                  pageContext.findAttribute("entry");
               
               Role role = null;
               RoleHandle answerSheetRoleHandle = null;
               DimensionalArea answerSheetArea = null;
               
               if (answerSheet != null)
               {
                  role = answerSheet.getRole(psession);
                  answerSheetRoleHandle = answerSheet.getRoleHandle();
                  answerSheetArea = answerSheet.getLocation(psession);
               }
            %>
               <mon:title><fmt:message key="AssessmentWizard.step.positions.txt"/></mon:title>     
               
               <display:column width="1%" title="<%= selColTitle %>">
                  <html:multibox property="answerSheets">
                     <%= answerSheet.getHandleString() %>
                  </html:multibox>
               </display:column>
               
               <display:column title='<%= bundle.getString("AssessmentWizard.positions.role.txt") %>' >
                  <c:out value="<%= role.getName() %>" />
               </display:column>
            
               <display:column title='<%= bundle.getString("AssessmentWizard.positions.scope.txt") %>' >
                  <c:out value="<%= answerSheetArea.toString(psession) %>" />
               </display:column>
               
               <display:column title='<%= bundle.getString("Assessments.questionnaires.assessors.txt") %>'
                     width="1%" align="center" headerClass="nwc">
            <%
               if (answerSheetRoleHandle != null)
               {
            %>
                  <a href="javascript:viewAssessors('<%= answerSheetRoleHandle %>', '<%= answerSheetArea.getHandleString() %>')"><img 
                     src="<%= request.getContextPath() %>/<fmt:message key="Assessments.viewAssessors.image" />"
                     alt="<fmt:message key="Assessments.questionnaires.button.viewAssessors.txt" />"
                     title="<fmt:message key="Assessments.questionnaires.button.viewAssessors.txt" />"
                     border="0"
                  /></a>
            <%
               }
            %>
               </display:column>
            
               <display:column title='<%= bundle.getString("application.preview.txt") %>'
                  width="1%" align="center" headerClass="nwc">
                  <a href="javascript:preview('<%= answerSheet.getHandleString() %>')"><img 
                     src="<%=request.getContextPath()%>/<fmt:message key="application.preview.image" />"
                     alt="<fmt:message key="application.preview.txt" />"
                     title="<fmt:message key="application.preview.txt" />"
                     border="0"/></a>
               </display:column>
            </mon:table>
            
            <script type="text/javascript">
            new CheckboxGroup("assessmentsForm", "answerSheets", "selectAll");
            </script>

         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
