<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
	boolean canCreate = SecurityUtils.canDoSomewhere(Do.CREATE, ScenarioTopic.object, psession);
   boolean canDelete = SecurityUtils.canDoSomewhere(Do.DELETE, ScenarioTopic.object, psession);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      <%-- not needed for now
      var statusMap = new Array();
      --%>
      
      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.queryForm.submit();
         return false;
      }
      
      function createScenarioTopic() {
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/ScenarioTopic.do?method=create";
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function createNewScenarioTopicFrom(handle) {
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/ScenarioTopic.do?method=createNew&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function updateActiveFlg(handle) {
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/ScenarioTopic.do?method=updateActiveFlg&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function deleteScenarioTopic(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "scenarioTopics.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            goScenarioTopic("delete", handle, false);
         }
      }
      
      function goScenarioTopic(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/ScenarioTopic.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, name, activeFlg, canUpdate) {
         var menu = new TableMenu();
         menu.addMenuItem(
               new MenuItem(
                  MenuItem.prototype.action,
                  "<fmt:message key='application.createNewFrom.image'/>", 
                  "<fmt:message key='application.createNewFrom.txt'/>", 
                  "javascript:createNewScenarioTopicFrom('" + handle + "')",
                  <%= canCreate %>));
         if (canUpdate){
            if (activeFlg){
               menu.addMenuItem(
                     new MenuItem(
                        MenuItem.prototype.action,
                        "<fmt:message key='application.deactivate.image'/>", 
                        "<fmt:message key='application.deactivate.txt'/>", 
                        "javascript:updateActiveFlg('" + handle + "')"));
            }
            else {
               menu.addMenuItem(
                     new MenuItem(
                        MenuItem.prototype.action,
                        "<fmt:message key='application.activate.image'/>", 
                        "<fmt:message key='application.activate.txt'/>", 
                        "javascript:updateActiveFlg('" + handle + "')"));
            }
         }
         menu.addMenuItem(
               new MenuItem(
                  MenuItem.prototype.action,
                  "<fmt:message key='application.delete.image'/>", 
                  "<fmt:message key='application.delete.txt'/>", 
                  "javascript:deleteScenarioTopic('" + handle + "','" + name + "')",
                  <%= canDelete %>));
         menu.render();
         return false;
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioTopicQuery">
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createScenarioTopicLink" onclick="createScenarioTopic(); return false;"><fmt:message key='scenarioTopics.create.button.txt'/></a>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="snoTopic" disableTableActions="true" >
            <mon:title><fmt:message key="scenarioTopics.title.txt"/></mon:title>
            <%
               final ScenarioTopic snoTopic = (ScenarioTopic)pageContext.findAttribute("snoTopic");
               final String handle = snoTopic == null? "": snoTopic.getHandleString();
               final String snoTopicName = snoTopic == null? "": ParsingUtils.escape(snoTopic.getScenarioTopicNm());
               final Boolean activeFlg = snoTopic == null? Boolean.TRUE : snoTopic.getActiveFlg();
               final boolean canUpdate = snoTopic == null? false : snoTopic.can(Do.UPDATE, psession);
            %>
               <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                  &nbsp;<a href="#" onclick="return showContextMenu('<%= handle %>', '<%= snoTopicName %>', <%= activeFlg.booleanValue() %>, <%= canUpdate %>)"
               ><img border="0"
                     src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                     alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                /></a>&nbsp;
               </mon:fixedColumn>
               
            </mon:tableComponent>
            <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
