<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.templates.*" %>
<%@page import="com.sas.oprisk.monitor.web.table.KriDecimalsCellFormatter"%>
<%@ page import="java.util.*" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final KriDefinitionAccessModel permission = new KriDefinitionAccessModel( psession );
   
   String createDefinitionURL = request.getContextPath() + "/KriDefinition.do?method=create";
   String createDefinitionBody = bundle.getString( "kri.DefinitionCreate.title" );

   String deleteDefinitionURL = request.getContextPath() + "/KriDefinition.do?method=delete";
   String deleteDefinitionColumn = bundle.getString( "kri.DefinitionQuery.deleteDefinition.title.txt" );

   String createIndicatorColumn = bundle.getString( "kri.DefinitionQuery.createIndicator.title" );

   String deleteMsg = ApplicationProperties.getProperty("KriTemplate.delete.confirm.txt",locale);
   String encodedMsg = com.sas.oprisk.framework.server.util.ParsingUtils.escape(deleteMsg);

   // check permissions
   boolean canCreateDefinitions = permission.userCanCreate();
   boolean canDeleteDefinitions = permission.userCanDelete();
   boolean canCreateIndicators = permission.userCanCreateKris();
   
   java.util.Map formatters = new java.util.HashMap();
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   KriDecimalsCellFormatter rangeFormatter = new KriDecimalsCellFormatter(mc);
   
   formatters.put("rangeMid1", rangeFormatter);
   formatters.put("rangeMid2", rangeFormatter);
   formatters.put("x_target", rangeFormatter);
   formatters.put("rangeMax", rangeFormatter);
   formatters.put("rangeMin", rangeFormatter);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createDefinition() {
         var f = document.forms.queryForm;
         f.action = '<%= createDefinitionURL %>'
         f.submit();
      }
      
      function confirmDelete()
      {
        var msg = unescape('<%=encodedMsg%>')
        return confirm(msg)
      }
      
      function deleteDefinition(handle) {
         if (confirmDelete()) {
            var f = document.forms.queryForm;
            f.action = '<%= deleteDefinitionURL %>' + '&handle=' + encodeURI(handle);
            f.submit();
         }
      }
      
      function createIndicator(handle) {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/KriIndicator.do"
               + "?method=create"
               + "&templateHandle=" + encodeURI(handle);
         f.submit();
      }
      
      </script>            
   </mon:Head>
   <mon:Body>      
      <html:form action="/KriDefinitionQuery">      
         <mon:ToolBar>
            <% if ( canCreateDefinitions ) { %>
                <a class="toolBarAction" href="#" id="createDefinitionLink" onclick="createDefinition(); return false;"><fmt:message key='kri.DefinitionCreate.button.txt'/></a>
            <% } %>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="definition"
               columnFormatters="<%= formatters %>"
               disableTableActions="true" >
            
            
            
            <% if ( canDeleteDefinitions ) { %>
              <mon:fixedColumn width="1%" before="false" title="<%= deleteDefinitionColumn %>" >
            
            <%  
                final KriTemplateEx definition = (KriTemplateEx) pageContext.findAttribute("definition");
                if ( definition.canBeDeleted( psession ) && definition.can( Do.DELETE, psession ) ) { %>
                  <a href="#" onclick="deleteDefinition('<c:out value='${definition.handleString}'/>')">
                     <img border="0" style="border:0px;"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                        alt="<fmt:message key='application.delete.tooltip.txt'/>"
                        title="<fmt:message key='application.delete.tooltip.txt'/>"
                  /></a>
            <%   } else { %>
            &nbsp;
            <%   } %>
            
              </mon:fixedColumn>
            <% } %>
            
            
            <% if ( canCreateIndicators ) { %>
            
              <mon:fixedColumn width="1%" before="false" title="<%= createIndicatorColumn %>" >
            <%
               final KriTemplateEx definition = (KriTemplateEx)pageContext.findAttribute("definition");
            %>
            <% if ( canCreateIndicators && (definition.getActiveFlg()!= null) && definition.getActiveFlg().booleanValue() ) { %>
                  <a href="#" onclick="createIndicator('<c:out value='${definition.handleString}'/>')">
                     <img border="0" style="border:0px;"
                        src="<%= request.getContextPath() %>/<fmt:message key='kri.DefinitionQuery.createNew.image'/>" 
                        alt="<fmt:message key='application.create.tooltip.txt'/>"
                        title="<fmt:message key='application.create.tooltip.txt'/>"
                  /></a>
            <% } else { %>
            &nbsp;
            <% } %>
            
              </mon:fixedColumn>
            <% } %>
            
            
            </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
