<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.tests.*" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);   
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      	+ bundle.getString("application.selectAll.tooltip.txt") + "\" />";
   
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("measures",   new TestMeasureCellFormatter(mc)); 
   formatters.put("testConclusions", new TestConclusionCellFormatter(mc));

   formatters.put("validationStateCd", new WorkflowApproveStateFormatter(mc));
   formatters.put("testInstStatusCd", new WorkflowApproveStateFormatter(mc));
   
   final String controlCertificationHandle = (String)request.getAttribute("controlCertificationHandle");
   final String exportUrl = request.getContextPath() 
      + "/ControlCertificationEdit.do"
      + "?method=export" 
      + "&controlCertificationHandle=" + controlCertificationHandle 
      + "&entryId=referencedTests";
   
%>    

<mon:include js="/script/checkboxRadioUtil.js" />

<script type="text/javascript">
   //method to show a pop-up window that will show the Tests that can be added.
   function addTests() {		
	openModal(
      		"<%= request.getContextPath() %>" 
	      	+ "/ControlLinkedTestsQuery.do?controlInstanceHandle="
	      	+ encodeURI(document.forms[0].controlInstanceHandle.value),
      		"TestsPopup", 
      		"width=680,height=480,scrollbars,resizable,status");
   }

   function removeReferencedTest(handle) {
      var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
      	"ControlCertification.removeTest.confirm.message.txt")) %>");
    	msg = formatMessage(msg);
      if (confirm(msg)) {	   	   	   
         document.forms.controlCertificationFormEx.testToRemove.value = handle;
         doControlCertification("removeReferencedTest");
      }
   }
   
   //call-back method that is invoked when the "Add Tests" popup is closed after selecting Tests.
   function addSelectedTests(selectionArray) {
   
   	// store selection array in hidden field
   	document.forms.controlCertificationFormEx.testsToAdd.value = selectionArray;
   	
   	// submit form and add selected controlds
   	doControlCertification("addReferencedTests");
   }
   
</script>

    <input type="hidden" name="testsToAdd" />
    <input type="hidden" name="testToRemove" />

    <mon:tableComponent entryName="referencedTests" id="referencedTest" wizCursor="refresh" exportXlsUrl="<%= exportUrl %>" columnFormatters="<%= formatters %>" >
       <mon:title><fmt:message key="controlCertification.referencedTests.table.title.txt"/></mon:title>    

<% 
   final boolean readOnly = Boolean.TRUE.equals((Boolean)pageContext.findAttribute("readOnly"));
   if(!readOnly) {
%>            
       <mon:action href='javascript:addTests()'><fmt:message key='controlCertification.referencedTests.addTests.link.title.txt'/></mon:action>&nbsp;|&nbsp;
<% } %>       
        <mon:fixedColumn width='1%' title='<%= bundle.getString("application.remove.txt") %>' before="false" >
            <a href="javascript:removeReferencedTest('<c:out value='${referencedTest.handleString}'/>')" >
               <img border="0" src="<fmt:message key='application.remove.image' />"  
                  alt="<fmt:message key='application.remove.txt'/>" 
                  title="<fmt:message key='application.remove.txt'/>"/>
            </a>
         </mon:fixedColumn>                
    </mon:tableComponent> 
    
