<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.util.RequestDebug" %>
<%@ page import="com.sas.solutions.cpb.runtime.UIContext" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil" %>
<%@ page import="com.sas.solutions.cpb.util.LabelKeyValue" %>
<%@ page import="com.sas.oprisk.server.cpb.uiDefType.CreateTestsUIDefinitionType" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.createTests.CreateTestsForm" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   final Boolean readOnlyBoolean = (Boolean)request.getAttribute("readOnly");
   final boolean readOnly = (readOnlyBoolean != null)? readOnlyBoolean.booleanValue() : true ;
   final String context = request.getContextPath();
   
   UIContext uiContext = UIContextUtil.getUIContext(request);
   LabelKeyValue source = (LabelKeyValue)uiContext.getValue(CreateTestsUIDefinitionType.FIELD_SOURCE);
   boolean notFromAudit = source != null ? !source.equals(CreateTestsForm.FROM_AUDIT) : false;
   
   final String exportRequest = request.getContextPath() + "/CreateTests.do?method=refresh";
%>
<%
   //RequestDebug.printParamAndAttributes("Tests", request);
%>
<script type="text/javascript">

function viewTesters( testHandle ) {
   var f = document.forms.createTestsForm;
   var extraParams = 'method=manageTesters&testHandle=' + encodeURI(testHandle);
   f.action = '<%= context %>/CreateTests.do?'  + extraParams;
   f.submit();
}

function popControlInstance( ciHandle ) {   
   openModal(
      "<%= request.getContextPath() %>" 
      + "/ControlInstance.do?method=select&handle="
      + encodeURI(ciHandle) + "&readOnly=true&popup=true",
      "ControlInstancePopup", 
      "width=750,height=550,scrollbars,resizable,status");
}

function showTestContextMenu(handle, ciHandle) {
	var menu = new TableMenu();
	
<% if (notFromAudit) { %>
	menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.selectuser.image'/>", "<fmt:message key='manageTesters.menu.txt'/>", "javascript:viewTesters('" + handle + "')"));
<% } %>	
	menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.viewdata.image'/>", "<fmt:message key='controlInstance.readOnly.menu.txt'/>", "javascript:popControlInstance('" + ciHandle + "')"));
	menu.render();
	return false;
}

</script>

<mon:tableComponent entryName="tests" id="test" wizCursor="refresh" exportXlsUrl='<%= exportRequest + "&entryId=tests" %>' >
   <!-- This title tag is not actually used. The title is specified in Custom Page XML label tag -->
   <mon:title><fmt:message key="createTests.section.tests.txt"/></mon:title>      
   
   <% 
   TestPlan tp = (TestPlan)pageContext.findAttribute("test");
   String ciHandle = null;
   if (tp != null) ciHandle = tp.getControlHandle().toString();
   %>

   <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
      &nbsp;<a href="#" onclick="return showTestContextMenu('<c:out value='${test.handleString}'/>', '<%=ciHandle %>')"
      ><img border="0"
         src="<%= context %>/<fmt:message key='application.showActionsButton.row.image'/>" 
         alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
         title="<fmt:message key='application.rowActions.tooltip.txt'/>"
         /></a>&nbsp;
   </mon:fixedColumn>
   <%
   boolean bOpen = false;
   if (tp != null) bOpen = tp.getTesterPool(psession).isModeOpen();
   %>
   
<% if (notFromAudit) { %>
   <mon:fixedColumn width='1%' title='<%= bundle.getString("controlTesting.testersAssigned.title.txt") %>' before="false" valign="top" >                 
         <%if(bOpen) { %>
      	   <fmt:message key='yesno.no.txt' />  
         <% } else { %>      
           <fmt:message key='yesno.yes.txt' />  
         <% } %>
   </mon:fixedColumn> 
<% } %>

</mon:tableComponent> 
