<%@ include file="/tiles/taglibs.jsp" %>


<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.server.base.*" %>
<%@ page import="com.sas.oprisk.server.*" %>

<%    
     Locale locale = request.getLocale();
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     String context = request.getContextPath();
%>

<mon:Page template="wizardbanner">
   <mon:Head>
      <mon:include js="/script/modalPopup.js" />
      <mon:include js="/ext/cpbcore/browser/Event.js" />
      <script type="text/javascript">
      
         function getForm() {
            return document.forms.controlTestingLibraryForm;
         }  
      
         function deletePolicy(handle, name) {
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
                  "businessPolicy.verifyDelete.fmt.txt")) %>");
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) doAction("deletePolicy", handle);
         }
      
         function doAction(method, handle) {
            beginWait();
            var f = getForm();
            f.action = "<%= context %>/BusinessPolicyEditor.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
            f.submit();
         }
      
      
      function showContextMenu( handle, name, isActive, canBeDeleted ) {
         
         var menu = new TableMenu();
      <c:if test="${canUpdate}">
         if ( isActive ) {
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/<fmt:message key='businessPolicy.disabled.image'/>", 
            "<fmt:message key='businessPolicy.activate.menuItem.txt'/>", "javascript:doAction('activatePolicy', '" + handle + "')", false ));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/<fmt:message key='businessPolicy.deactivate.image'/>", 
            "<fmt:message key='businessPolicy.deactivate.menuItem.txt'/>", "javascript:doAction('deactivatePolicy', '" + handle + "')", true ));
         } else {
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/<fmt:message key='businessPolicy.activate.image'/>", 
            "<fmt:message key='businessPolicy.activate.menuItem.txt'/>", "javascript:doAction('activatePolicy', '" + handle + "')", true ));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/<fmt:message key='businessPolicy.disabled.image'/>", 
            "<fmt:message key='businessPolicy.deactivate.menuItem.txt'/>", "javascript:doAction('deactivatePolicy', '" + handle + "')", false ));
         }
      </c:if>
      <c:if test="${canDelete}">
         if ( canBeDeleted ) {
         menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/" + "<fmt:message key='application.delete.image'/>", 
            "<fmt:message key='certificationPeriod.delete.menuItem.txt'/>", "javascript:deletePolicy('" + handle + "', '" + name + "')" ));
         }
      </c:if>
         menu.render();
         return false;
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ControlTestingLibrary.do?method=businessPolicies">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:tableComponent id="businessPolicy">
     
            <c:if test="${canUpdate || canDelete}" >
              <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
         <%
         final BusinessPolicyEx bp = (BusinessPolicyEx) pageContext.findAttribute("businessPolicy");
         final String escName = ParsingUtils.escape(bp.getName());
         final boolean isActive = bp.getActiveFlg().booleanValue();
         final boolean canBeDeleted = bp.canBeDeleted(psession);
         %>
               &nbsp;<a href="#" onclick="return showContextMenu('<c:out value='${businessPolicy.handleString}'/>', '<%= escName %>', <%= isActive %>, <%= canBeDeleted %>)"
                  ><img border="0"
                      src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                     alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     title="<fmt:message key='application.rowActions.tooltip.txt'/>"
              /></a>&nbsp;
              </mon:fixedColumn>
              </c:if>
              
           </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
