<%@ include file="/tiles/taglibs.jsp" %>


<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.server.base.CertificationPeriodStatusCd" %>
<%@ page import="com.sas.oprisk.server.CertificationPeriod" %>

<%    
     Locale locale = request.getLocale();
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     String context = request.getContextPath();
%>

<mon:Page template="wizardbanner">
   <mon:Head>
      <mon:include js="/script/modalPopup.js" />
      <mon:include js="/ext/cpbcore/browser/Event.js" />
      <script type="text/javascript">
      
         function getForm() {
            return document.forms.controlTestingLibraryForm;
         }     
         function createCertificationPeriod() {
            var f = getForm();
            f.action = 
                "<%= context %>" + "/CertificationPeriodEdit.do?method=create";     
            f.submit();
         }
         
         function deleteCertificationPeriod(handle, name) {
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
                  "certificationPeriod.verifyDelete.fmt.txt")) %>");
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) doAction("deletePeriod", handle);
         }     
            
         function doAction(method, handle) {
            beginWait();
            var f = getForm();
            f.action = "<%= context %>/CertificationPeriodEdit.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
            f.submit();
         }
      
      
      function showContextMenu( handle, statusCd, name, canBeDeleted ) {
         var nyo = '<%= CertificationPeriodStatusCd.notYetOpen.getValue() %>' == statusCd;
         var open = '<%= CertificationPeriodStatusCd.open.getValue() %>' == statusCd;
         var closed = '<%= CertificationPeriodStatusCd.closed.getValue() %>' == statusCd;
         
         var menu = new TableMenu();
      <c:if test="${canUpdate}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/" + (nyo ? "<fmt:message key='certificationPeriod.open.image'/>" : "<fmt:message key='certificationPeriod.disabled.image'/>"), 
            "<fmt:message key='certificationPeriod.open.menuItem.txt'/>", "javascript:doAction('openPeriod', '" + handle + "')", nyo ));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/" + (open ? "<fmt:message key='certificationPeriod.close.image'/>" : "<fmt:message key='certificationPeriod.disabled.image'/>"), 
            "<fmt:message key='certificationPeriod.close.menuItem.txt'/>", "javascript:doAction('closePeriod', '" + handle + "', true)", open ));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/" + (closed ? "<fmt:message key='certificationPeriod.reopen.image'/>" : "<fmt:message key='certificationPeriod.disabled.image'/>"), 
            "<fmt:message key='certificationPeriod.reopen.menuItem.txt'/>", "javascript:doAction('reopenPeriod', '" + handle + "')", closed ));
         if ( canBeDeleted ) {
         menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= context %>/" + "<fmt:message key='application.delete.image'/>", 
            "<fmt:message key='certificationPeriod.delete.menuItem.txt'/>", "javascript:deleteCertificationPeriod('" + handle + "', '" + name + "')" ));
         }
      </c:if>
         menu.render();
         return false;
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ControlTestingLibrary.do?method=certificationPeriods">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:tableComponent id="certificationPeriod">
           <c:if test="${requestScope.canCreate}">
            <mon:action href="javascript:createCertificationPeriod();"><fmt:message key='controlTesting.createCertificationPeriod.link.txt'/></mon:action>      
           </c:if>
           
           <c:if test="${canCreate || canUpdate || canDelete}" >
           <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
      <%
      final CertificationPeriod cp = (CertificationPeriod) pageContext.findAttribute("certificationPeriod");
      final String escName = ParsingUtils.escape(cp.getName());
      final boolean canBeDeleted = cp.canBeDeleted(psession);
      %>
            &nbsp;<a href="#" onclick="return showContextMenu('<c:out value='${certificationPeriod.handleString}'/>', '<c:out value='${certificationPeriod.certificationPeriodStatusCd}'/>', '<%= escName %>', <%= canBeDeleted %>)"
               ><img border="0"
                   src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"
           /></a>&nbsp;
           </mon:fixedColumn>
           </c:if>
           
        </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
