<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>

<%@ page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.testers.PotentialTesterPosition" %>


<%-- ****************************************************************** --%>
<%-- testerAssignmentSummary.jsp --%>
<%-- ****************************************************************** --%>

<%    

final java.util.Locale locale = request.getLocale();
final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
String selAllUsersTitle = "<input type=\"checkbox\" name=\"selectUsers\" title=\"" 
   + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
   
String selAllPosTitle = "<input type=\"checkbox\" name=\"selectPositions\" title=\"" 
   + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
   
String testersTitle =
   bundle.getString("potentialTesterPosition.field.testers.displayName.txt");

final String tip = bundle.getString("application.selectuser.tooltip.txt"); 
final String img = bundle.getString("application.selectuser.image");

final String exportRequest = request.getContextPath() + "/ManageTesters.do?method=view";

try {
%>

<mon:Page template="details">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">
      
      function performAction( actionName, methodName, addnlArg ) {
          document.forms.testerAssignmentForm.action = 
                      "<%= request.getContextPath()+'/' %>"
              + actionName + "?method=" + methodName;
          document.forms.testerAssignmentForm.submit();
      }
      
      function requestMethod( methodName, addnlArg ) {
          performAction('ManageTesters.do', methodName );
      }
      
      
      
      function openUserChooser() {     
        openModal(
          "<%= request.getContextPath() %>" 
          + "/PotentialTestersQuery.do?containerHandle="
          + encodeURI(document.forms[0].containerHandle.value),
           "potentialTesterUsersPopup", 
          "width=680,height=480,scrollbars,resizable,status");
      }
      
      function openPositionChooser() {
        openModal(
          "<%= request.getContextPath() %>" 
          + "/PotentialTesterPositionsQuery.do?containerHandle="
          + encodeURI(document.forms[0].containerHandle.value),
           "potentialTesterPositionsPopup", 
          "width=680,height=480,scrollbars,resizable,status");
      }
      
      // method to add the selected users from "Add Users" window.
      function addSelectedUsers( selectionArray ) 
      {
         // store selection array in hidden field
         document.forms.testerAssignmentForm.usersToAddOrRemove.value = selectionArray;
      
         // submit form and add selected controlds
         requestMethod('addUsers');
      }
      
      function removeUser(user, handle) {
          var msg = unescape("<%= ParsingUtils.escape(bundle.getString("manageTesters.removeUser.confirm.message.fmt.txt")) %>");
          msg = formatMessage(msg, user);
          if (confirm(msg)) {            
             document.forms.testerAssignmentForm.usersToAddOrRemove.value = handle;
             requestMethod( 'removeUsers' );
          }
      }
      
      
      // method to add the selected positions from "Add Positions" window.
      function addSelectedPositions( selectionArray ) 
      {
         // store selection array in hidden field
         document.forms.testerAssignmentForm.positionsToAddOrRemove.value = selectionArray;
      
         // submit form and add selected controlds
         requestMethod('addPositions');
      }
      
      function removePosition(role, location, handle) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString("manageTesters.removePosition.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, role, unescape(location));
         if (confirm(msg)) {
            document.forms.testerAssignmentForm.positionsToAddOrRemove.value = handle;
            requestMethod( 'removePositions' );
         }
      }
      
      function showPositionMembership(positionHandle) {
      //window.alert("positionHandle="+positionHandle);
         openModal(
            "<%= request.getContextPath() %>" +
            "/PositionMembershipQuery.do?positionHandle="+encodeURI(positionHandle), 
            'user_popup', 'width=750,height=500,scrollbars,resizable');
         return false;
      }
      
      <%------------------------------%>
      
      function updateMode(newValue) {
          var radioLength = document.forms[0].mode.length;
          
          for(var i = 0; i < radioLength; i++) {
             if(document.forms[0].mode[i].value == newValue.toString()) {
               if (!document.forms[0].mode[i].checked) {
                  document.forms[0].mode[i].checked = true;
               }
             } else {
               if (document.forms[0].mode[i].checked) {
                    document.forms[0].mode[i].checked = false;
               }
             }
          }

          setVisible("userTableDiv", "user" == newValue);  
          setVisible("positionTableDiv", "position" == newValue);   
       }
               
      </script>
      
      <style type="text/css" >
         .displayTable {
            width: 100%;
         }
      </style>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ManageTesters">      
         <mon:ToolBar>
            <c:if test='${model.canEdit}'>
               <mon:Button name="save" onclick="requestMethod('save')">
                  <fmt:message key='okButton.txt' />
               </mon:Button>
               <mon:Button name="cancel" onclick="requestMethod('cancel')">
                  <fmt:message key='cancelButton.txt' />
               </mon:Button>                                  
            </c:if>
            <c:if test='${not model.canEdit}'>
               <mon:Button name="cancel" onclick="requestMethod('cancel')">
                  <fmt:message key='returnButton.txt' />
               </mon:Button>
            </c:if>
         </mon:ToolBar>
         
         <mon:Content>
            <p class="instructions">
               <fmt:message key="manageTesters.modeWarning.txt">
                  <fmt:param><%= SmartLabelTag.REQUIRED_INDICATOR %></fmt:param>
               </fmt:message>
            </p>
            
               <html:hidden property="containerHandle" />
               <html:hidden property="poolId" />
               
               <html:hidden property="readOnly" />
            
               <input type="hidden" name="usersToAddOrRemove" />
               <input type="hidden" name="positionsToAddOrRemove" />
            
              <mon:DimAreaChooser 
               property="location"
               rootVisible="true"   
               feature="<%= BusinessObjectFeatureInfo.TEST_DEFINITION.getFeatureName() %>"
               readOnly='true' />
                
              <br/>
            
            <fieldset>
            <legend><fmt:message key="manageTesters.selectBy.txt" /></legend>
            <html:radio property="mode" value="user" onclick="updateMode('user')" disabled="${model.isModeFrozen}"/><fmt:message key="manageTesters.selectByUsers.txt" />
            <html:radio property="mode" value="position" onclick="updateMode('position')" disabled="${model.isModeFrozen}"/><fmt:message key="manageTesters.selectByPosition.txt" />
            </fieldset>
            
            <div id="userTableDiv" <c:if test="${model.pool.mode.name != 'user'}">style="display:none"</c:if>>
                <mon:tableComponent entryName="users" id="user" wizCursor="view" exportXlsUrl='<%= exportRequest + "&entryId=users" %>' >
                   <mon:title><fmt:message key="manageTesters.userTable.title.txt"/></mon:title>
                   <c:if test="${model.canEdit}">  
                   <mon:action href='javascript:openUserChooser()'><fmt:message key='manageTesters.addUsers.txt'/></mon:action>&nbsp;|&nbsp;                           
                   <mon:fixedColumn width='1%' title='<%= bundle.getString("application.remove.txt") %>' before="false" >
                        <a href="javascript:removeUser('<c:out value='${user.displayNm}'/>', '<c:out value='${user.handle}'/>')" >
                           <img border="0" src="<fmt:message key='application.remove.image' />"  
                              alt="<fmt:message key='application.remove.txt'/>" 
                              title="<fmt:message key='application.remove.txt'/>"/>
                        </a>
                     </mon:fixedColumn> 
                   </c:if>
                </mon:tableComponent>
            </div>
            
            <div id="positionTableDiv" <c:if test="${model.pool.mode.name != 'position'}">style="display:none"</c:if>>
                <mon:tableComponent entryName="positions" id="position" wizCursor="view" exportXlsUrl='<%= exportRequest + "&entryId=positions" %>' >
                   <mon:title><fmt:message key="manageTesters.positionTable.title.txt"/></mon:title>       
                   <c:if test="${model.canEdit}">  
                    <mon:action href='javascript:openPositionChooser()'><fmt:message key='manageTesters.addPositions.txt'/></mon:action>&nbsp;|&nbsp;                
                     <mon:fixedColumn width='1%' title='<%= bundle.getString("application.remove.txt") %>' before="false" >
                        <a href="javascript:removePosition('<c:out value='${position.role}'/>', '<%=ParsingUtils.escape(ParsingUtils.escape(((PotentialTesterPosition)pageContext.findAttribute("position")).getLocation()))%>', '<c:out value='${position.handle}'/>')" >
                         <img border="0" src="<fmt:message key='application.remove.image' />"  
                              alt="<fmt:message key='application.remove.txt'/>" 
                              title="<fmt:message key='application.remove.txt'/>"/>
                        </a>
                     </mon:fixedColumn> 
                   </c:if>
                   <mon:fixedColumn width="10" title="<%= testersTitle %>" before="false">
                     <a href='#' onclick='javascript:showPositionMembership("<c:out value="${position.handle}"/>");'><img src="<%= img %>" border="0" alt="<%= tip %>" title="<%= tip %>"></a>
                   </mon:fixedColumn>
                  
                </mon:tableComponent>
            </div>
            
            
            <script type="text/javascript">
              // initialize table visibility 
              var testerMode = document.forms.testerAssignmentForm.mode.value; 

              
              var mode = '<c:out value="${model.assignmentMode}" />';

              if (mode == "open") {
                  mode = "user"; // default use "user" mode
              }
              updateMode( mode );            
            </script>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

<%
} catch ( Throwable t)
{ t.printStackTrace(); }
%>

