<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.tests.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>

<%    
     Locale locale = request.getLocale();
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     
     boolean canCreateTestInGeneral = TestPlan.object.canSomewhere(Do.CREATE, psession);
     boolean canDeleteTestInGeneral = TestPlan.object.canSomewhere(Do.DELETE, psession);
     
     MonitorContext mc = MonitorContext.getMonitorContext(request);
     java.util.Map formatters = new java.util.HashMap();
     formatters.put("measures",   new TestMeasureCellFormatter(mc)); 
     formatters.put("testConclusions", new TestConclusionCellFormatter(mc));
     formatters.put("validationStateCd", new WorkflowApproveStateFormatter(mc));
     formatters.put("testInstStatusCd", new WorkflowApproveStateFormatter(mc));
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/script/modalPopup.js" />
      <mon:include js="/ext/cpbcore/browser/Event.js" />
      <script type="text/javascript">
      
         function getForm() {
         return document.forms.queryForm;
         }
               
         function cloneTest(handle) {
            var f = getForm();
            f.action =
               "<%= request.getContextPath() %>/TestPlanEdit.do" 
               + "?method=cloneTest&handle=" + encodeURI(handle);      
            f.submit();
         }
      
         //when a Test is selected from the list of Tests shown in the GUI, this javascript method will be
         //called from the action.
         //Note that the handle is implicitly set!
         function selectTest(handle) {   
            var f = getForm();
            f.action = "<%= request.getContextPath() %>/TestInstanceEditor.do"
         + "?handle=" + handle;
            f.submit();
         }
      
         function deleteTest(handle, name) {
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
                  "test.removeTest.confirm.message.fmt.txt")) %>");
            // apm: msg does not currently use the test name
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) {
               var f = getForm();
               f.action = "<%= request.getContextPath() %>/TestPlanEdit.do?method=delete"
                  + "&handle=" + encodeURI(handle);
               f.submit();
            }
         }
      
         function showContextMenu(handle, name, canCreateTest, canDeleteTest, isNotAuditTest) {
            var menu = new TableMenu();
      
            if (canCreateTest == "true"){
         menu.addMenuItem(
            new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/" + "<fmt:message key='application.createNew.image'/>", 
            "<fmt:message key='test.createNewTestFrom.menu.txt'/>", 
            "javascript:cloneTest('" + handle + "')", 
            isNotAuditTest));
            }
      
            if (canDeleteTest == "true"){
               menu.addMenuItem(
                  new MenuItem(MenuItem.prototype.action,
                      "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                      "<fmt:message key='application.delete.txt'/>", 
                      "javascript:deleteTest('" + handle + "', '" + name + "')", 
                      true));
            }
            menu.render();
            return false;
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/TestsQuery">      
         <mon:ToolBar>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="test" columnFormatters="<%= formatters %>" disableTableActions="true" >
               <mon:title><fmt:message key="controlTesting.TestsQuery.title"/></mon:title>
               <% if (canCreateTestInGeneral || canDeleteTestInGeneral) {
                     TestInstanceEx test = (TestInstanceEx)pageContext.findAttribute("test");
                     if (test != null) {
                        boolean canCreate = test.canCreate(psession);
                        boolean canDelete = test.canDelete(psession);
                        boolean isNotAuditTest = test.getAuditIsNull().booleanValue();
                        String name = ParsingUtils.escape(test.getTitleTxt());
               %>
                  <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                     &nbsp;
                     <a href="#" onclick="return showContextMenu('<c:out value='${test.handleString}'/>', '<%= name %>', '<%= canCreate %>', '<%= canDelete %>', <%= isNotAuditTest %> )">
                     <img border="0"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                        alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                        title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     />
                     </a>
                     &nbsp;
                  </mon:fixedColumn>
               <%    }
               }
               %>            
                     
           </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
