<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="com.sas.solutions.cpb.runtime.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.xml.validator.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.runtime.*" %>
<%@ page import="com.sas.oprisk.monitor.web.iap.issue.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final IssueModel model = (IssueModel)request.getAttribute("model");
   
   final UIContext uiContext = RequestUtil.getUIContext(request);
   Object areaHandle = uiContext.getValue("location");
   String areaHandleStr = ""; 
   if (areaHandle instanceof DimensionalAreaHandle) {
      areaHandleStr = areaHandle.toString();
   }
%>
<mon:Page template="details">
<mon:Head>
<%-- BEGIN HEAD --%>
<%@ include file="/layout/ModalScriptIncludes.jsp" %>
<mon:include js="/dwr/interface/IAPService.js" />

<script type="text/javascript">
var popupAnchor;

function doIssue(method, anchor) {
   lockCommandButtons();

   var f = document.forms[0];
   f.action = "<%= request.getContextPath() %>/Issue.do"
      + "?method=" + method;
      
   if (anchor) {
      f.action = f.action + "#" + anchor;
   }
      
   f.submit();
}

function doWorkflowStatus(status, msg) {
   lockCommandButtons();
   var doIt = true;	

   if (msg != "") {
      if (!confirm(msg)) {
         unLockCommandButtons();
         doIt = false;
      }
   }

   if (doIt) {
      // show the "Please Wait" dialog (if configured)
      beginWait();
      
      var f = document.forms[0];	
      f.action = "<%= request.getContextPath() %>/SaveIssue.do?method=workflow&workflow.status=" + status;
      f.submit();
   }
}


function doSave(method) {
   lockCommandButtons();

   var f = document.forms[0];
   if (!method) {
      method = 'save';
   }
   f.action = "<%= request.getContextPath() %>/SaveIssue.do?method=" + method;
   f.submit();
}

function forward(path, refreshMethod, params) {
   var method = "forward";
   if (refreshMethod) {
      method += "&rm=" + refreshMethod;
   }
   if (params) {
      method += params;
   }
   method += "&path=" + escape(path);
   doIssue(method);
}

function reassign() {
   var f = document.forms[0];
   var area = f.LOCATION ? f.LOCATION.value : '<%= areaHandleStr %>';

   openModal("<%= request.getContextPath() %>/UserQueryForIssueReassignOwner.do"
      + "?iHandle=" + encodeURI("<c:out value='${uiContext.handle}' />")
      + "&area=" + encodeURI(area),
      "owner_popup");
}

<%-- currently only used for refreshing after a linked item is added --%>
function popupCloser_refresh(method) {
   if (!method) {
      method = "refreshLinkedItems";
   }
   doIssue(method, popupAnchor);
}

function viewIssue(handle)
{
   forward("/Issue.do?method=select&handle=" + handle);
}

function deleteCertification(method, handle){
   forward("/Issue.do?method=select&handle=" + handle);
   return false;
}

addLoadEvent(setFocus);
</script>
<%-- END HEAD --%>
</mon:Head>

<mon:Body>
<%-- BEGIN BODY --%>

<html:form action="/Issue" >
<input type="hidden" name="handle" value="<c:out value="${uiContext.handle}" />" />
<input type="hidden" name="fromIssue" value="true" /> <%-- only used in IssuesTableTag  --%>

<mon:ToolBar>
<%-- BEGIN TOOLBAR --%>
<c:if test="${model.hasApprovalWorkflow}">
   <c:forEach var="action" items="${model.workflowStatuses}" varStatus="status">            
      <mon:Button name="actionButton${status.count}" 
         value="${action.name}" 
         onclick="doWorkflowStatus('${action.action}','${action.escapedConfirmation}')" />
   </c:forEach>
</c:if>

<c:if test="${!model.hasApprovalWorkflow}">

   <c:if test="${(model.canSave || model.canSaveAsDraft)}">
      <mon:Button name="actionButtonSave" onclick="doSave()">
         <c:if test="${model.canSaveAsDraft}">
            <fmt:message key='iap.IssueView.button.draft.txt'/>
         </c:if>
         <c:if test="${!model.canSaveAsDraft}">
            <fmt:message key='application.button.save.txt'/>
         </c:if>
      </mon:Button>
   </c:if>
   
   <c:if test="${model.canLock}">
      <mon:Button name="actionButtonSave" onclick="doIssue('lock')">
         <fmt:message key='iap.IssueView.button.beginMod.txt'/>
      </mon:Button>
   </c:if>
   
   <c:if test="${model.canUnlock}">
      <mon:Button name="actionButtonSave" onclick="doSave('unlock')">
         <fmt:message key='application.button.close.txt'/>
      </mon:Button>
   </c:if>
   
   <c:if test="${model.canPublish}">
      <mon:Button name="actionButtonPublish" onclick="doSave('publish')">
         <c:if test="<%=!com.sas.oprisk.server.workflow.IAPWorkflow.isApprovalForIssuePublishEnabled()%>"><fmt:message key='iap.IssueView.button.publish.txt'/></c:if>
         <c:if test="<%=com.sas.oprisk.server.workflow.IAPWorkflow.isApprovalForIssuePublishEnabled()%>"><fmt:message key='iap.IssueView.button.send.for.publish.approval.txt'/></c:if>
      </mon:Button>
   </c:if>
   
   <c:if test="${model.canDelete}"> 
      <mon:Button name="actionButtonDelete" onclick="doIssue('delete')">
         <fmt:message key='application.button.delete.txt'/>
      </mon:Button>
   </c:if>

   <%-- these buttons only show up if the issue is readonly --%>   
   <c:if test="${model.readOnly}"> 
   
      <c:if test="${model.canAccept}"> 
         <mon:Button name="actionButtonAccept" onclick="doIssue('accept')">
            <fmt:message key='iap.IssueView.button.accept.txt'/>
         </mon:Button>
      </c:if>
   
      <c:if test="${model.canReassign}"> 
         <mon:Button name="actionButtonReassign" onclick="reassign()">
            <fmt:message key='iap.IssueView.button.reassign.txt'/>
         </mon:Button>
      </c:if>
   
      <c:if test="${model.canMarkAsClosed}"> 
         <mon:Button name="actionButtonClose" onclick="doIssue('markAsClosed')">
            <c:if test="<%=!com.sas.oprisk.server.workflow.IAPWorkflow.isApprovalForIssueCloseEnabled()%>"><fmt:message key='iap.IssueView.button.approve.txt'/></c:if>
            <c:if test="<%=com.sas.oprisk.server.workflow.IAPWorkflow.isApprovalForIssueCloseEnabled()%>"><fmt:message key='iap.IssueView.button.send.for.close.approval.txt'/></c:if>
         </mon:Button>
      </c:if>
   
      <c:if test="${model.canMarkAsCanceled}"> 
         <mon:Button name="actionButtonCancel" onclick="doIssue('markAsCanceled')">
            <c:if test="<%=!com.sas.oprisk.server.workflow.IAPWorkflow.isApprovalForIssueCancelEnabled()%>"><fmt:message key='iap.IssueView.button.cancelIssue.txt'/></c:if>
            <c:if test="<%=com.sas.oprisk.server.workflow.IAPWorkflow.isApprovalForIssueCancelEnabled()%>"><fmt:message key='iap.IssueView.button.send.for.cancel.approval.txt'/></c:if>
         </mon:Button>
      </c:if>
   
      <c:if test="${model.canReinstate}"> 
         <mon:Button name="actionButtonReinstate" onclick="doIssue('reinstate')">
            <fmt:message key='iap.IssueView.button.reinstate.txt'/>
         </mon:Button>
      </c:if>
      
      <c:if test="${model.canValidate}"> 
         <mon:Button name="actionButtonValidate" onclick="doIssue('validate')">
         	<fmt:message key='iap.IssueView.button.verify.txt'/>
         </mon:Button>
      </c:if>
      
      <c:if test="${model.canInvalidate}"> 
         <mon:Button name="actionButtonInvalidate" onclick="doIssue('invalidate')">
            <fmt:message key='iap.IssueView.button.unverify.txt'/>
         </mon:Button>
      </c:if>
      
   </c:if>

</c:if>
         
<mon:Button name="actionButtonCancel" onclick="doIssue('cancel')">
   <c:if test="${!model.readOnly}">
      <fmt:message key='application.button.cancel.txt'/>
   </c:if>
   <c:if test="${model.readOnly}">
      <fmt:message key='application.button.done.txt'/>
   </c:if>
</mon:Button>

<%-- END TOOLBAR --%>
</mon:ToolBar>

<mon:Content>
<%-- BEGIN CONTENT --%>
<cpb:screen screenID="issue" readOnly="<%= model.isReadOnly() %>" />
<%-- END CONTENT --%>
</mon:Content>

</html:form>

<%-- END BODY --%>
</mon:Body>
   
<%-- END PAGE --%>
</mon:Page>