<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.insurancepolicy.actions.*" %>

<%@ page import="java.util.*" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);

   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final InsurancePolicyAccessModel permission = new InsurancePolicyAccessModel( psession );

   String createInsurancePolicyURL = request.getContextPath() + "/InsurancePolicy.do?method=create";
   String queryInsurancePolicyURL  = request.getContextPath() + "/InsurancePolicyQuery.do?";

   String statusPolicyColumnTitle = bundle.getString( "TC.tableComponent.isActive.txt" );
   String deletePolicyColumnTitle = bundle.getString( "TC.queryEditor.button.delete.txt" );
   String deletePolicyUrl = request.getContextPath() + "/InsurancePolicyDelete.do?";
   String deleteMsg = ApplicationProperties.getProperty("InsurancePolicy.delete.confirm.txt",locale);
   String encodedMsg = com.sas.oprisk.framework.server.util.ParsingUtils.escape(deleteMsg);

   // check permissions
   boolean userCanCreate = permission.userCanCreate();
   boolean userCanDelete = permission.userCanDelete();

   Date date = new Date();
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

         function createInsurancePolicy() {
            var f = document.forms.insurancePolicyQueryForm;
            f.action = "<%= createInsurancePolicyURL %>" 
                     + "&filterType=" + f.filterType.value;
            f.location.value = f.TCArea.value;
            f.submit();
         }
      
         function confirmDelete() {
            var msg = unescape('<%=encodedMsg%>')
            return confirm(msg)
         }
      
         function deleteRequest(handle) {
            if(confirmDelete()) {
               var f = document.forms.insurancePolicyQueryForm;
               f.action = '<%= deletePolicyUrl %>' + "&handle=" + encodeURI(handle);
               f.submit();
            }
         }
      
         function filterPolicies() {
            var f = document.forms.insurancePolicyQueryForm;
            f.action = "<%= queryInsurancePolicyURL %>";
            f.submit();
         }
         
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/InsurancePolicyQuery">   
         <mon:Content>
            <mon:tableComponent id="policy" >

            <% if ( userCanCreate ) { %>
              <mon:action href="javascript:createInsurancePolicy();"><fmt:message key='InsurancePolicyCreate.newLink.txt'/></mon:action>
            <% } %>
      
            <mon:filter> <!-- begin status filter -->
              <fmt:message key="application.status.txt"/>:&nbsp;
            
              <html:select property="filterType">
                <html:option value="<%=InsurancePolicyConstants.ALL_FILTER_TYPE%>"> 
                  <fmt:message key='application.all.txt'/>
                </html:option>
                <html:option value="<%=InsurancePolicyConstants.ACTIVE_FILTER_TYPE%>"> 
                  <fmt:message key='application.active.txt'/>
                </html:option>
                <html:option value="<%=InsurancePolicyConstants.INACTIVE_FILTER_TYPE%>">
                  <fmt:message key='application.inactive.txt'/>
                </html:option>
              </html:select>
      
              &nbsp;&nbsp;
      
              <input type="button" class="button"
                onmouseover="this.className='button buttonRollover'"
                onmouseout="this.className='button'"
                value="&nbsp;<fmt:message key='goButton.txt' />&nbsp;" 
                onclick="filterPolicies()" />
         
              <br/><br/>
            </mon:filter> <!-- end status filter -->
      
            <mon:fixedColumn before="false" title="<%= statusPolicyColumnTitle %>" >
      <%
               final InsurancePolicy policy = (InsurancePolicy)pageContext.findAttribute("policy");
               if(policy.isActive(date)) { %>
                  <fmt:message key='application.yes.txt'/>
      <%       } else { %>     
                  <fmt:message key='application.no.txt'/>
      <%       } %>
            </mon:fixedColumn>
      
            <mon:fixedColumn width="1%" before="false" title="<%= deletePolicyColumnTitle %>" >
              <% if ( userCanDelete ) { %>
               <a href="#" onclick="deleteRequest('<c:out value='${policy.handleString}'/>')">
                  <img border="0" style="border:0px"
                    src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                    alt="<fmt:message key='application.delete.tooltip.txt'/>"
                    title="<fmt:message key='application.delete.tooltip.txt'/>"
                  />
                </a>
              <% } else { %>
                &nbsp;
              <% } %>
            </mon:fixedColumn>
      
          </mon:tableComponent>
          
          <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
