<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   Map colFormatters = (Map)request.getAttribute("colFormatters");
   boolean canCreate = SecurityUtils.canDoSomewhere(Do.CREATE, Policy.object, psession);
   boolean canDelete = SecurityUtils.canDoSomewhere(Do.DELETE, Policy.object, psession);
   pageContext.setAttribute("canCreate", new Boolean(canCreate));
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/dwr/engine.js"/>
      <mon:include js="/dwr/util.js"/>
      <mon:include js="/dwr/interface/CommonService.js"/>
      
      <script type="text/javascript">

         function createPolicy()
         {
            var form = document.forms.queryForm;
            form.action = "<%= request.getContextPath() %>/Policy.do?method=create";
            form.LOCATION.value = form.TCArea.value;
            form.submit();
         }
         
         function deletePolicy( policyHandle, name ) {
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
               "policy.delete.confirm.message.fmt.txt")) %>");
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) {
               doAction('delete', policyHandle);
            } 
         }
      
         function showContextMenu(handle, name)
          {
            CommonService.getWorkableActivitiesJSONString(
               "<%= BusinessObjectTypeInfo.POLICY.getClassObject().getPointerTag() %>|" + handle,
               function(jsonStr)
               {
                  var array = eval('(' + jsonStr + ')');
                  var menu = new TableMenu();
                  for (var i = 0; i < array.length; i++)
                  {
                     menu.addMenuItem(
                        new MenuItem(
                           MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.viewdata.image'/>", 
                           array[i].label + "<fmt:message key='application.ellipsis.txt'/>",
                           array[i].url, 
                           true));
                  }
                  if (<%= canCreate %> || <%= canDelete %>)
                  {
                     menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
                  }
                  if (<%= canCreate %>)
                  {
                     menu.addMenuItem(
                        new MenuItem(
                           MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.createNewFrom.image'/>", 
                           "<fmt:message key='application.createNewFrom.tooltip.txt'/>", 
                           "javascript:doAction('createNewFrom', '" + handle + "')", 
                           <%= canCreate %>));
                  }
                  if (<%= canDelete %>)
                  {
                     menu.addMenuItem(
                        new MenuItem(
                           MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                           "<fmt:message key='application.deleteElipses.txt'/>", 
                           "javascript:deletePolicy('" + handle + "', '" + name + "')", 
                           <%= canDelete %>));
                  }
                  menu.render();
               }
            );
            return false;
         }
         
         function doAction(method, handle)
         {
            beginWait();
            var form = document.forms.queryForm;
            form.action = "<%= request.getContextPath() %>/Policy.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
            form.submit();
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/PolicyQuery">
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createPolicyButton" onclick="createPolicy(); return false;">
                  <fmt:message key='policy.create.button.txt'/>
               </a>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <input type="hidden" name="LOCATION"/>
   
            <mon:tableComponent columnFormatters="<%= colFormatters %>" id="policy" disableTableActions="true" >
               <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                  &nbsp;
                  <%
                     Policy policy = (Policy)pageContext.findAttribute("policy");
                     String policyNm = policy == null ? "" : ParsingUtils.escape(policy.getPolicyNm());
                     String handleString = policy == null ? "" : policy.getHandleString();
                  %>
                  <a href="#" onclick="return showContextMenu('<%= handleString %>', '<%= policyNm %>')">
                     <img border="0"
                          src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                          alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                          title="<fmt:message key='application.rowActions.tooltip.txt'/>"/>
                  </a>
                  &nbsp;
               </mon:fixedColumn>
            </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

