<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   Map colFormatters = (Map)request.getAttribute("colFormatters");
   boolean canDelete = SecurityUtils.canDoSomewhere(Do.DELETE, ProcessInstance.object, psession);
%>


<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createProcessInstance() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ProcessInstanceAction.do"
               + "?method=create";
         f.LOCATION.value = f.TCArea.value;
         f.submit();
      }
      
      function doAction(method, handle)
      {
         var form = document.forms.queryForm;
         form.action = "<%= request.getContextPath() %>/ProcessInstanceAction.do"
            + "?method=" + method
            + "&handle=" + encodeURI(handle);
         form.submit();
      }
      
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/ProcessInstanceQuery">
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createProcessInstanceLink" onclick="createProcessInstance(); return false;"><fmt:message key='processInstance.create.txt'/></a>
            </c:if>
            <mon:SavedView></mon:SavedView>
         </mon:ToolBar>
         <mon:Content>
            <mon:tableComponent columnFormatters="<%=colFormatters%>" id="processInstance" >
               
<%
   if (canDelete)
   {
      ProcessInstance entry = (ProcessInstance)pageContext.findAttribute("processInstance");
%>
               <mon:fixedColumn title='<%= bundle.getString("application.delete.txt") %>' width="1%" before="false">
                  &nbsp;
                  <a href="javascript:doAction('delete', '<%= entry.getHandleString() %>')">
                     <img border="0"
                          src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                          alt="<fmt:message key='application.delete.txt'/>"
                          title="<fmt:message key='application.deleteElipses.txt'/>"/>
                  </a>
                  &nbsp;
               </mon:fixedColumn>
<%
   }
%>
            </mon:tableComponent>
            
            <input type="hidden" name="LOCATION" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>