<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.IssueThresholdAppliesToCellFormatter" %>
<%@ include file="/tiles/taglibs.jsp" %>
      
<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final User currentUser = (User) psession.getUser();
   final boolean canCreateIssueThreshold = SecurityUtils.canDoSomewhere(Do.CREATE, Threshold.object, psession);
   final boolean canUpdateIssueThreshold = SecurityUtils.canDoSomewhere(Do.UPDATE, Threshold.object, psession);
   final boolean canDeleteIssueThreshold = SecurityUtils.canDoSomewhere(Do.DELETE, Threshold.object, psession);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function deleteThreshold(handle){
         if (confirm("<fmt:message key='issueThreshold.deleteThreshold.confirmation.txt' />")){
            doIssueThreshold('delete', handle);
         }
      }
      
      function doIssueThreshold(method, handle) {
         document.forms.queryForm.action = "<%= request.getContextPath() %>/IssueThreshold.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, deactivate, canDelete) {
         var menu = new TableMenu();
         
         if (deactivate == "true"){
            menu.addMenuItem(
               new MenuItem(MenuItem.prototype.action,
                  "<%= request.getContextPath() %>/" + "<fmt:message key='application.deactivate.image'/>", 
                  "<fmt:message key='issueThreshold.button.deactivate.txt'/>", 
                  "javascript:doIssueThreshold('deactivate', '" + handle + "')", 
                  true));
         }
         else {
            menu.addMenuItem(
               new MenuItem(MenuItem.prototype.action,
                  "<%= request.getContextPath() %>/" + "<fmt:message key='application.activate.image'/>", 
                  "<fmt:message key='issueThreshold.button.reactivate.txt'/>", 
                  "javascript:doIssueThreshold('reactivate', '" + handle + "')", 
                  true));
         }
         
         if (canDelete == 'true'){
            menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
            menu.addMenuItem(
               new MenuItem(MenuItem.prototype.action,
                  "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                  "<fmt:message key='issueThreshold.button.delete.txt'/>", 
                  "javascript:deleteThreshold('" + handle + "')", 
                  true));
         }
         menu.render();
         return false;
      }
      
      function createIssueThreshold(){
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>" + "/IssueThreshold.do?method=create";
         f.submit();
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/IssueThresholdQuery">      
         <mon:ToolBar>
            <% if (canCreateIssueThreshold) { %>
               <a class="toolBarAction" href="#" onclick="createIssueThreshold(); return false;"><fmt:message key='issueThreshold.button.create.txt'/></a>
            <% } %>
            <mon:SavedView></mon:SavedView>
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="issueThreshold" disableTableActions="true" >
            
            
            <% if (canUpdateIssueThreshold) { %>
               <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                  &nbsp;
                  <a href="#" onclick="return showContextMenu('<c:out value='${issueThreshold.handleString}'/>', '<c:out value='${issueThreshold.activeFlg}'/>', '<%= canDeleteIssueThreshold %>' )">
                     <img border="0"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                        alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                        title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     />
                  </a>
                  &nbsp;
               </mon:fixedColumn>
            <% } %>
               
               <mon:column fieldName="thresholdTypeCd" 
                           formatter="com.sas.oprisk.monitor.web.incident.cellFormatter.IssueThresholdAppliesToCellFormatter" >
               </mon:column>
            
            
            </mon:tableComponent>            
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
